Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports Microsoft.VisualBasic

namespace HowTo.ADONET24.Samples

Public Class OptConSample

  Private Shared Sub OnRowUpdated(sender As Object, updevent As SqlRowUpdatedEventArgs)
     If updevent.RecordsAffected = 0
        updevent.Row.RowError = "Optimistic Concurrency Violation"
        updevent.Status = UpdateStatus.SkipCurrentRow
     End If
   End Sub

  Public Shared Sub Main()
    Dim nwindConn As SqlConnection = New SqlConnection("Data Source=C81124-E\DBARCH01;Integrated Security=SSPI;Initial Catalog=northwind")

    Dim CustomerAdapter As SqlDataAdapter = New SqlDataAdapter("SELECT CustomerID, CompanyName, ContactName FROM Customers ORDER BY CustomerID", nwindConn)

  CustomerAdapter.UpdateCommand = New SqlCommand("UPDATE Customers (CustomerID, CompanyName, ContactName) VALUES(@CustomerID, @CompanyName, @ContactName) " & _
"WHERE CustomerID = @oldCustomerID AND CompanyName = @oldCompanyName AND ContactName = @oldContactName", nwindConn)

  CustomerAdapter.UpdateCommand.Parameters.Add("@CustomerID", SqlDbType.NChar, 5, "CustomerID")
  CustomerAdapter.UpdateCommand.Parameters.Add("@CompanyName", SqlDbType.NVarChar, 40, "CompanyName")
  CustomerAdapter.UpdateCommand.Parameters.Add("@ContactName", SqlDbType.NVarChar, 30, "ContactName")

 'Set up OldParms to hold the rows original values 
 'These are then used in the WHERE clause for the optimistic concurrency comparison

  Dim OldParms As SqlParameter
  OldParms = CustomerAdapter.UpdateCommand.Parameters.Add("@oldCustomerID", SqlDbType.NChar, 5, "CustomerID")
  OldParms.SourceVersion = DataRowVersion.Original

  OldParms = CustomerAdapter.UpdateCommand.Parameters.Add("@oldCompanyName", SqlDbType.NVarChar, 40, "CompanyName")
  OldParms.SourceVersion = DataRowVersion.Original

  OldParms = CustomerAdapter.UpdateCommand.Parameters.Add("@oldContactName", SqlDbType.NVarChar, 30, "ContactName")
  OldParms.SourceVersion = DataRowVersion.Original

  'Add Customer RowUpdaed Event Handler.

  AddHandler CustomerAdapter.RowUpdated, New SqlRowUpdatedEventHandler(AddressOf OnRowUpdated) 

  Dim CustomerDataSet As DataSet = New DataSet()

  Console.Writeline ("Go get some customer data - Fill")
  CustomerAdapter.Fill(CustomerDataSet, "Customers")

  Console.Writeline ("Update the rows")
  CustomerAdapter.Update(CustomerDataSet, "Customers")

  Dim CustRow As DataRow

  Console.Writeline ("Look for optimistic concurrency violations")
  For Each CustRow In CustomerDataSet.Tables("Customers").Rows
    Console.Writeline ("Looking for errors for row with CustomerID of "& CustRow(0) )
    If CustRow.HasErrors Then Console.WriteLine(CustRow(0) & vbCrLf & CustRow.RowError)
    if not CustRow.HasErrors then Console.Writeline ("No optimistic concurrency error found")
  Next

  Console.Writeline ("Show contents of DataSet")
  For each CustRow in CustomerDataSet.Tables("Customers").Rows
      Console.Writeline("Customer Contacts Selected: " + CustRow("ContactName").ToString())
  Next

 End Sub
End Class
End namespace