Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports Microsoft.VisualBasic

namespace HowTo.ADONET24.Samples

Public Class OptConSampleTSE

  Public Shared Sub Main()
    Dim nwindConn As SqlConnection = New SqlConnection("Data Source=C81124-E\DBARCH01;Integrated Security=SSPI;Initial Catalog=northwind")

    Dim CustomerAdapter As SqlDataAdapter = New SqlDataAdapter("SELECT CustomerID, ContactName, timestamp FROM CustomersTS WHERE CustomerID like 'B%' ORDER BY CustomerID", nwindConn)

  CustomerAdapter.UpdateCommand = New SqlCommand("UPDATE CustomersTS (CustomerID, ContactName, timestamp) VALUES(@CustomerID, @ContactName, null) " & _
"WHERE CustomerID = @oldCustomerID AND tsequal (timestamp, @oldTimestamp) ", nwindConn)

  CustomerAdapter.UpdateCommand.Parameters.Add("@CustomerID", SqlDbType.NChar, 5, "CustomerID")
  CustomerAdapter.UpdateCommand.Parameters.Add("@ContactName", SqlDbType.NVarChar, 40, "ContactName")

 'Set up OldParms to hold the rows original values 
 'These are then used in the WHERE clause for the optimistic concurrency comparison

  Dim OldParms As SqlParameter
  OldParms = CustomerAdapter.UpdateCommand.Parameters.Add("@oldCustomerID", SqlDbType.NChar, 5, "CustomerID")
  OldParms.SourceVersion = DataRowVersion.Original
  OldParms = CustomerAdapter.UpdateCommand.Parameters.Add("@oldContactName", SqlDbType.NChar, 30, "CustomerID")
  OldParms.SourceVersion = DataRowVersion.Original

  OldParms = CustomerAdapter.UpdateCommand.Parameters.Add("@oldTimestamp", SqlDbType.Varbinary, 8, "timestamp")
  OldParms.SourceVersion = DataRowVersion.Original


  Dim CustomerDataSet As DataSet = New DataSet()

  Console.Writeline ("Go get some customer data - Fill")
  CustomerAdapter.Fill(CustomerDataSet, "CustomersTS")

  Console.Writeline ("Update the rows")
  CustomerAdapter.Update(CustomerDataSet, "CustomersTS")

  Dim CustRow As DataRow

  Console.Writeline ("Look for optimistic concurrency violations")
  For Each CustRow In CustomerDataSet.Tables("CustomersTS").Rows
    Console.Writeline ("Looking for errors for row with CustomerID of "& CustRow(0) )
    If CustRow.HasErrors Then Console.WriteLine(CustRow(0) & vbCrLf & CustRow.RowError)
    if not CustRow.HasErrors then Console.Writeline ("No Error Found")
  Next

  Console.Writeline ("Show contents of DataSet")
  For each CustRow in CustomerDataSet.Tables("CustomersTS").Rows
      Console.Writeline("Customers: " + CustRow("CustomerID").ToString() + " " +       CustRow("ContactName").ToString() )
  Next

 End Sub
End Class
End namespace