CREATE PROCEDURE Employee_Add
(
	@LastName nvarchar(20),
	@FirstName nvarchar(10),
	@Title nvarchar(30),
	@BirthDate datetime,
	@HireDate datetime,
	@Address nvarchar(60),
	@City nvarchar(15),
	@PostalCode nvarchar(10),
	@TerritoryID nvarchar(20)
)

AS

	DECLARE @iCommunityProductAuditID int

	BEGIN TRAN
	
	-- add the main record
	INSERT INTO Employees
	(
		LastName,
		FirstName,
		Title,
		BirthDate,
		HireDate,
		Address,
		City,
		PostalCode	
	)
	VALUES
	(
		@LastName,
		@FirstName,
		@Title,
		@BirthDate,
		@HireDate,
		@Address,
		@City,
		@PostalCode	
	)

	IF @@ERROR <> 0 
	BEGIN
	  ROLLBACK TRAN
	  RETURN @@ERROR
	END

        -- get EmployeeID
	declare @EmployeeID int
	SET @EmployeeID = @@IDENTITY

	-- add employee to a territory
        INSERT INTO EmployeeTerritories
        (
        	EmployeeID,
		TerritoryID
        )
	VALUES
	(
		@EmployeeID,
		@TerritoryID
	)

	IF @@ERROR <> 0 
	BEGIN
	  ROLLBACK TRAN
	  RETURN @@ERROR
	END

	COMMIT TRAN

	RETURN @@ERROR
GO
