        Public Function GetProductDetails(ByVal productID As Integer) _
                                                            As ProductDetails

            'Create Instance of Connection and Command Objects
            Dim conn as New SqlConnection( _
                        ConfigurationSettings.AppSettings("ConnectionString"))
            Dim cmd as New SqlCommand("Product_Get", conn)

            'Mark the Command as a Stored Procedure
            cmd.CommandType = CommandType.StoredProcedure

            ' Add Parameters to SPROC
            Dim parameterProductID As SqlParameter = _
                              New SqlParameter("@ProductID", SqlDbType.Int, 4)
            parameterProductID.Value = productID
            cmd.Parameters.Add(parameterProductID)

            Dim parameterProductName As SqlParameter = _
                      New SqlParameter("@ProductName", SqlDbType.NVarChar, 40)
            parameterProductName.Direction = ParameterDirection.Output
            cmd.Parameters.Add(parameterProductName)
            
            Dim parameterQuantityPerUnit As SqlParameter = _
                  New SqlParameter("@QuantityPerUnit", SqlDbType.NVarChar, 20)
            parameterQuantityPerUnit.Direction = ParameterDirection.Output
            cmd.Parameters.Add(parameterQuantityPerUnit)

            Dim parameterUnitPrice As SqlParameter = _
                            New SqlParameter("@UnitPrice", SqlDbType.Money, 8)
            parameterUnitPrice.Direction = ParameterDirection.Output
            cmd.Parameters.Add(parameterUnitPrice)

            Dim parameterUnitsInStock As SqlParameter = _
                      New SqlParameter("@UnitsInStock", SqlDbType.SmallInt, 2)
            parameterUnitsInStock.Direction = ParameterDirection.Output
            cmd.Parameters.Add(parameterUnitsInStock)
            
            Dim parameterDiscontinued As SqlParameter = _
                      New SqlParameter("@Discontinued", SqlDbType.SmallInt, 2)
            parameterDiscontinued.Direction = ParameterDirection.Output
            cmd.Parameters.Add(parameterDiscontinued)
            
            Dim parameterImagePath As SqlParameter = _
                        New SqlParameter("@ImagePath", SqlDbType.NVarChar, 50)
            parameterImagePath.Direction = ParameterDirection.Output
            cmd.Parameters.Add(parameterImagePath)

            ' Open the connection and execute the Command
            conn.Open()
            cmd.ExecuteNonQuery()
            conn.Close()

            'Create and Populate ProductDetails Struct using
            'Output Params from the SPROC
            Dim myProductDetails As ProductDetails = New ProductDetails()

            myProductDetails.ProductName = _
                           Convert.ToString(parameterProductName.Value).Trim()
            myProductDetails.QuantityPerUnit = _
                       Convert.ToString(parameterQuantityPerUnit.Value).Trim()
            myProductDetails.UnitPrice = _
                                   Convert.ToDecimal(parameterUnitPrice.Value)
            myProductDetails.UnitsInStock = _
                                  Convert.ToInt16(parameterUnitsInStock.Value)
            myProductDetails.Discontinued = _
                         Convert.ToBoolean(parameterDiscontinued.Value)
            myProductDetails.ImagePath = _
                             Convert.ToString(parameterImagePath.Value).Trim()
            
            Return myProductDetails

        End Function
