        Public Function UpdateProducts( ProductID as Int32, _
                                        ProductName as string, _
                                        QuantityPerUnit as string, _
                                        UnitPrice as string, _
                                        UnitsInStock as Int16, _
                                        ImagePath as string, _
                                        Discontinued as Boolean ) as Int32
        
            'Create Instance of Connection and Command Objects
            Dim conn as New SqlConnection( _
                        ConfigurationSettings.AppSettings("ConnectionString"))
            Dim cmd as New SqlCommand("Product_Update", conn)

            'Mark the Command as a Stored Procedure
            cmd.CommandType = CommandType.StoredProcedure

            ' Add Parameters to SPROC
            Dim parameterProductID As SqlParameter = _
                              New SqlParameter("@ProductID", SqlDbType.Int, 4)
            parameterProductID.Value = productID
            cmd.Parameters.Add(parameterProductID)    
            
            Dim parameterProductName As SqlParameter = _
                      New SqlParameter("@ProductName", SqlDbType.NVarChar, 40)
            parameterProductName.Value = ProductName
            cmd.Parameters.Add(parameterProductName)
            
            Dim parameterQuantityPerUnit As SqlParameter = _
                  New SqlParameter("@QuantityPerUnit", SqlDbType.NVarChar, 20)
            parameterQuantityPerUnit.Value = QuantityPerUnit
            cmd.Parameters.Add(parameterQuantityPerUnit)

            Dim parameterUnitPrice As SqlParameter = _
                            New SqlParameter("@UnitPrice", SqlDbType.Money, 8)
            parameterUnitPrice.Value = Convert.ToDecimal(UnitPrice)
            cmd.Parameters.Add(parameterUnitPrice)

            Dim parameterUnitsInStock As SqlParameter = _
                      New SqlParameter("@UnitsInStock", SqlDbType.SmallInt, 2)
            parameterUnitsInStock.Value = Convert.ToInt16(UnitsInStock)
            cmd.Parameters.Add(parameterUnitsInStock)
            
            Dim parameterImagePath As SqlParameter = _
                        New SqlParameter("@ImagePath", SqlDbType.NVarChar, 50)
            parameterImagePath.Value = ImagePath
            cmd.Parameters.Add(parameterImagePath)  
            
            Dim parameterDiscontinued As SqlParameter = _
                      New SqlParameter("@Discontinued", SqlDbType.Bit, 1)
            parameterDiscontinued.Value = Discontinued
            cmd.Parameters.Add(parameterDiscontinued)
            
            Dim parameterRowsAffected As SqlParameter = _
                              New SqlParameter("@RowsAffected", SqlDbType.Int, 4)
            parameterRowsAffected.Direction = ParameterDirection.Output
            cmd.Parameters.Add(parameterRowsAffected)    
            
            conn.Open()
            cmd.ExecuteNonQuery()
            conn.Close()
            
            Return Convert.ToInt32(parameterRowsAffected.Value)
               
        End Function
