<% @Page Language="VB" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<HTML>
<HEAD>
	<LINK rel="stylesheet" type="text/css" href="Main.css">
	<!-- End Style Sheet -->
	
	<script language="VB" runat="server" >
        Sub Page_Load(Source as Object, E as EventArgs)
            
            'Get ProductID and store in Viewstate
            Dim ProductID As Integer = Int32.Parse(Request.Params("ProductID"))
            if ProductID <> "" then
                ViewState("ProductID") = ProductID
            end if
            
            if IsPostBack then
            
                UpdateData( Convert.ToInt32(ViewState("ProductID")) )
                            
            end if
                  
            LoadData( ProductID )

        End Sub
  
        Private Sub UpdateData( productID as Int32 )
        
            Dim iResults as Int32
             
            Dim product as new ADO24HRS.ProductsDB()
            iResults = product.UpdateProducts( _
                        productID, _                        
                        txtProductName.Text, _
                        txtQuantityPerUnit.Text, _
                        txtUnitPrice.Text, _
                        txtUnitsInStock.Text, _
                        txtImagePath.Text, _
                        chkDiscontinued.Checked )
 
            if iResults = 1 then            
                lblOutput.Text = "Record successfully updated!"
            else
                lblOutput.Text = "There was a problem updating the record"
            end if
        
        End Sub
  
        Private Sub LoadData( productID as Int32 )
               
            'Declare new instance of ProductsDB   
            Dim products as New ADO24HRS.ProductsDB() 
            
            'Declare new instance of custom class
            Dim myProductDetails as ADO24HRS.ProductDetails
            
            'Fill custom class with data
            myProductDetails = products.GetProductDetails( productID )
             
            txtProductName.Text = myProductDetails.ProductName
            txtQuantityPerUnit.Text = myProductDetails.QuantityPerUnit
            txtUnitPrice.Text = myProductDetails.UnitPrice.ToString()
            txtUnitsInStock.Text = myProductDetails.UnitsInStock.ToString()
            ProductImage.Src = "/ADO24HOURS" + myProductDetails.ImagePath
            txtImagePath.Text = myProductDetails.ImagePath.ToString()
            chkDiscontinued.Checked = myProductDetails.Discontinued
      
        End Sub
	</script>
	
</HEAD>
<BODY>

<h1>Edit Product Details</h1>
<hr>

<form runat="server" id=form1 name=form1>

<asp:label id="lblOutput" runat="server" />

<table cellpadding=5>
  <tr>
    <td>      
      <img id="ProductImage" height=144 width=144 runat="server">
    </td>
    <td valign="center">
      <table>
        <tr>
          <td>
            <strong>Product Name: </strong> 
          </td>
          <td>         
            <asp:TextBox id="txtProductName" runat="server" />
          </td>
        </tr>
        <tr>
          <td>      
            Quantity Per Unit: 
          </td>
          <td>
            <asp:TextBox id="txtQuantityPerUnit" runat="server" />
          </td>
        </tr>
        <tr>
          <td>
            Units In Stock: 
          </td>
          <td>
            <asp:TextBox id="txtUnitsInStock" runat="server" />
          </td>
        </tr>
        <tr>
          <td>
            Price Per Unit:
          </td>
          <td>
            <asp:TextBox id="txtUnitPrice" runat="server" />
          </td>
        </tr>
        <tr>
          <td>
            Image Path:
          </td>
          <td>
            <asp:TextBox id="txtImagePath" runat="server" />
          </td>
        </tr>
        <tr>
          <td>  
            Product Discontinued:
          </td>
          <td>
            <asp:CheckBox id="chkDiscontinued" runat="server" />
          </td>
        </tr>
        <tr>
          <td>  
            &nbsp;
          </td>
          <td>
            <input type="submit" value="Submit Changes">
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>

</form>
<hr>

</BODY>
</HTML>
