CREATE PROCEDURE LoadTestData
(
	@rowcount bigint
)
AS

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[TestData]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[TestData]
GO

CREATE TABLE [dbo].[TestData] (
	[TestID] [int] IDENTITY (1, 1) NOT NULL ,
	[Name] [varchar] (40) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Address] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Address2] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[City] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[State] [char] (2) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Zip] [varchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Description] [varchar] (500) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
GO

declare @identity bigint
select @identity = 0

WHILE ( @identity < @rowcount )

BEGIN

INSERT INTO TestData
(
	[Name],
	Address,
	City,
	State,
	Zip,
	[Description]	
)
VALUES
(
	'Jason Lefebvre',
	'11 Longfellow St.',
	'Pawtucket',
	'RI',
	'Zip',
	'The quick brown fox jumps over the lazy dog.  The quick brown fox jumps over the lazy dog.  The quick brown fox jumps over the lazy dog.'
)
select @identity = @@IDENTITY
END
