<% @Page Language="VB" Debug=true%>
<%@ Import Namespace="System.Data" %>

<HTML>
<HEAD>
	    <LINK rel="stylesheet" type="text/css" href="24Hours.css">
	    <!-- End Style Sheet -->
	    
	    <script language="VB" runat="server" >
      Sub Page_Load(Source as Object, E as EventArgs )
         ' Create Principle Objects
         Dim dsCompany as new DataSet()
         
         ' Create new datatables
         Dim dtEmployees as DataTable = GenerateCompanyDataTable()
         Dim dtProjects as DataTable = GenerateProjectDataTable()
         
         ' Add new datatables to the dataset
         dsCompany.Tables.Add( dtEmployees )
         dsCompany.Tables.Add( dtProjects )
    
         ' Create Relationships between tables in datasets
         dsCompany.Relations.Add("EmployeeProjects", _
                     dsCompany.Tables("Employees").Columns("EmployeeID"), _
                     dsCompany.Tables("Projects").Columns("EmployeeID"))
    
         ' Bind to a datagrid to see DataTable data
         employees.DataSource = dtEmployees
         employees.DataBind()
         
         ' Bind to a datagrid to see DataTable data
         projects.DataSource = dtProjects
         projects.DataBind()       
         
         
         
         Dim strBuilder as new StringBuilder()        
         Dim EmployeeRow as DataRow
         Dim ProjectRow as DataRow
         
         ' Display Employees and the projects they are currently
         ' Assigned to
         for each EmployeeRow in dtEmployees.Rows
            strBuilder.Append("<BR>" + "***************************" + "<BR>")
            strBuilder.Append("EmployeeID: " + _ 
                  EmployeeRow("EmployeeID").ToString() + "<BR>" + _
                  "EmployeeName: " + EmployeeRow("FirstName").ToString() + _
                  " " + EmployeeRow("LastName").ToString() + "<BR>")
            for each projectRow in EmployeeRow.GetChildRows("EmployeeProjects")
              strBuilder.Append("<b>Currently working on:</b> " + "<BR>" + _
                                "ProjectID: " + _
                                projectRow("ProjectID").ToString() + "<BR>" + _
                                "ProjectName: " + _
                                projectRow("ProjectName").ToString() + "<BR>")
            next
         next
         
         lblProjects.Text = strBuilder.ToString()
      End Sub
      
      public Function GenerateCompanyDataTable() as DataTable
         'Create Principle Objects
         
         Dim dtEmployees as new DataTable("Employees")
         
         'Create Columns
         dtEmployees.Columns.Add("EmployeeID", Type.GetType("System.Int32"))
         dtEmployees.Columns.Add("FirstName", Type.GetType("System.String"))
         dtEmployees.Columns.Add("LastName", Type.GetType("System.String"))
         
         'Make the first column autoincrementing
         dtEmployees.Columns(0).AutoIncrement = true
         
         'Create column array
         Dim dcPrimaryKey(2) as DataColumn
         
         'Place EmployeeID in the column array
         dcPrimaryKey(0) = dtEmployees.Columns("EmployeeID")
         
         'Set the primary key for the table using the column array
         dtEmployees.PrimaryKey = dcPrimaryKey
         
         'Create new row
         Dim workRow as DataRow = dtEmployees.NewRow()
         workRow("FirstName") = "John"
         workRow("LastName") = "Fruscella"
         dtEmployees.Rows.Add(workRow)
         
         'Create another row
         Dim workRow1 as DataRow = dtEmployees.NewRow()
         workRow1("FirstName") = "Santa"
         workRow1("LastName") = "Claus"         
         dtEmployees.Rows.Add(workRow1)
         
         Return dtEmployees
      End Function
      
      public Function GenerateProjectDataTable() as DataTable
         'Create Principle Objects
         Dim dtProjects as DataTable = new DataTable("Projects")
         
         'Create Columns
         dtProjects.Columns.Add("ProjectID", Type.GetType("System.Int32"))
         dtProjects.Columns.Add("EmployeeID", Type.GetType("System.Int32"))
         dtProjects.Columns.Add("ProjectName", Type.GetType("System.String"))
         dtProjects.Columns.Add("ProjectDescription", _
                                   Type.GetType("System.String"))
         
         'Make the first column autoincrementing
         dtProjects.Columns(0).AutoIncrement = true
         
         'Create column array
         Dim dcPrimaryKey(2) as DataColumn
         
         'Place EmployeeID in the column array
         dcPrimaryKey(0) = dtProjects.Columns("ProjectID")
         dcPrimaryKey(1) = dtProjects.Columns("EmployeeID")
         
         'Set the primary key for the table using the column array
         dtProjects.PrimaryKey = dcPrimaryKey
         
         'Create new row - Assign EmployeeID 2 to this project
         Dim workRow as DataRow = dtProjects.NewRow()
         workRow("EmployeeID") = 1
         workRow("ProjectName") = "Landslide"
         workRow("ProjectDescription") = "Super secret Web services project."
         dtProjects.Rows.Add(workRow)
         
         'Create new row - Assign EmployeeID 1 to this project
         Dim workRow1 as DataRow = dtProjects.NewRow()
         workRow1("EmployeeID") = 0
         workRow1("ProjectName") = "Avalanche"
         workRow1("ProjectDescription") = "Super secret user control project."
         dtProjects.Rows.Add(workRow1)
         
         Return dtProjects
      End Function
      
	    </script>
	    
</HEAD>
<BODY>

<h1>ADO.NET In 24 Hours Examples</h1>
<hr>

<form runat="server" id=form1 name=form1>
   <asp:Label id="lblMessage" runat="server"></asp:Label>
   
   <p>
   <strong>Employees:</strong><br>
   <asp:DataGrid id="employees" runat="server"></asp:DataGrid>
   
   <p>
   <strong>Projects:</strong><br>
   <asp:DataGrid id="projects" runat="server"></asp:DataGrid>
   
   <p>
   <asp:Label id="lblProjects" runat="server"></asp:Label>
</form>

<hr>
</BODY>
</HTML>
